/**
 *
 */
package abc.parser;

import java.util.regex.Pattern;

/**
 * 定数定義
 *
 * @author CrapeMyrtle
 *
 */
public final class Constant {
	public static final String	INFO_FIELD_KEY_SEP		= ":";
	public static final String	INFO_FIELD_KEY_CLEF		= "clef";

	public static final String	STR_LENGTH				= "(\\d+)?(/(?:/+|\\d+)?)?";
	public static final String	STR_STRING				= "((?:\\\\.|[^\"])*)";
	public static final String	STR_OVERLAY_SEP			= "\t";
	public static final String	STR_ANNOTATION			= "\"(\\^|_|<|>|@)" + STR_STRING + "\"";
	public static final String	STR_SYMBOL				= "!([^!]+)!";

	public static final Pattern	PTN_INFO_FIELD			= Pattern.compile("^([a-zA-Z]):\\s*(.*)$");
	public static final Pattern	PTN_INLINE_INFO_FIELD	= Pattern.compile("^([a-zA-Z]):\\s*((?:\\\\.|[^\\]])*)");

	public static final Pattern	PTN_SKIP				= Pattern.compile("^\\s+");
	public static final Pattern	PTN_SYMBOL				= Pattern.compile("^" + STR_SYMBOL);
	public static final Pattern	PTN_ANNOTATION			= Pattern.compile("^" + STR_ANNOTATION);
	public static final Pattern	PTN_STRING				= Pattern.compile("^\"" + STR_STRING + "\"");
	public static final Pattern	PTN_LENGTH				= Pattern.compile("^" + STR_LENGTH);
	public static final Pattern	PTN_CHORD_STRING		= Pattern.compile("^\"([A-G](?:b|#)?)(m|min|maj|dim|aug|\\+|sus|\\d+)?(/[A-G](?:b|#)?)?\"");
	public static final Pattern	PTN_LENGTH_DEN			= Pattern.compile("^/(\\d+)");
	public static final Pattern	PTN_REST				= Pattern.compile("^(x|z)" + STR_LENGTH);
	public static final Pattern	PTN_MEASURE_REST		= Pattern.compile("^(X|Z)(\\d+)?");
	public static final Pattern	PTN_NOTE				= Pattern.compile("^(\\^{1,2}|=|_{1,2})?([a-gA-G])('+|,+)?"
																+ STR_LENGTH);
	public static final Pattern	PTN_BAR					= Pattern.compile("^(\\.)?(\\||\\[|\\]|:+)");
	public static final Pattern	PTN_REPEAT				= Pattern.compile("^(\\d+(?:\\s*-\\s*\\d+)?)(?:\\s*,\\s*\\d+(?:\\s*-\\s*\\d+)?)*");
	public static final Pattern	PTN_REPEAT_START		= Pattern.compile("[\\|\\[\\]]+(:+)(?:$|\\s+)");
	public static final Pattern	PTN_REPEAT_END			= Pattern.compile("(?:^|\\s+)(:+)[\\|\\[\\]]+");
	public static final Pattern	PTN_REPEAT_START_END	= Pattern.compile("(?:^|\\s+)(:{2,})(?:$|\\s+)");
	public static final Pattern	PTN_BROKEN				= Pattern.compile("^(<+|>+)");
	public static final Pattern	PTN_TIE					= Pattern.compile("^-");
	public static final Pattern	PTN_GROUP_NOTES			= Pattern.compile("^\\(([2-9])(?::([1-9][0-9]*)?)?(?::([1-9][0-9]*)?)?");
	public static final Pattern	PTN_VOICE_OVERLAY		= Pattern.compile("^(&+)");
	public static final Pattern	PTN_GRACE_START			= Pattern.compile("^\\{(/)?");
	public static final Pattern	PTN_GRACE_END			= Pattern.compile("^\\}");
	public static final Pattern	PTN_VELOCITY			= Pattern.compile("^v:\\s*(\\d+)");
	public static final Pattern	PTN_VOLUME				= Pattern.compile("^V:\\s*(\\d+)");
	public static final Pattern	PTN_SLUR_START			= Pattern.compile("^\\.?(\\()");
	public static final Pattern	PTN_SLUR_END			= Pattern.compile("^\\.?(\\))");
	public static final Pattern	PTN_DECORATION			= Pattern.compile("^([\\.])");
	public static final Pattern	PTN_SPACE				= Pattern.compile("^y");

	public static final Pattern	PTN_PROGRAM_ID			= Pattern.compile("^%%MIDI\\s+program\\s(\\d+)");

}
