/**
 *
 */
package abc.parser;

import java.util.regex.Matcher;
import java.util.regex.Pattern;
import abc.score.InformationFieldDefine;

/**
 * information fieldにあるU:フィールドのパーサ
 *
 * @author CrapeMyrtle
 *
 */
public class ParserInformationFieldDefine {
	private static final Pattern	PTN_TEXT	= Pattern.compile("\\s*([~h-wH-W])\\s*=\\s*("
														+ Constant.STR_ANNOTATION + "|"
														+ Constant.STR_SYMBOL + ")");

	/**
	 * 文字列を解析する
	 *
	 * @param str
	 *            解析する文字列
	 * @return information fieldのU:フィールド
	 */
	public InformationFieldDefine parse(String str) {
		Matcher m = PTN_TEXT.matcher(str);
		if (m.find()) {
			return new InformationFieldDefine(m.group(1), m.group(2));
		}

		return null;
	}
}
