/**
 *
 */
package abc.parser;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import abc.score.InformationFieldClef;
import abc.score.InformationFieldVoice;

/**
 * information fieldにあるV:フィールドのパーサ
 *
 * @author CrapeMyrtle
 *
 */
public class ParserInformationFieldVoice {

	private static final Pattern	PTN_TEXT	= Pattern
														.compile("\\s*([^\\s]+)(?=\\s|$)");

	/**
	 * 文字列を解析する
	 *
	 * @param str
	 *            解析する文字列
	 * @return information fieldのV:フィールド
	 */
	public InformationFieldVoice parse(String str) {
		// TODO かなり適当なのでうまくいかないものもあるかも
		// オプションっぽいもの全て無視

		String text = "";

		Matcher m = PTN_TEXT.matcher(str);
		if (m.find()) {
			text = m.group(1);
			str = m.replaceFirst("");
		}

		InformationFieldClef clef = new ParserInformationFieldClef().parse(str);

		return new InformationFieldVoice(text, clef);
	}
}
