/**
 *
 */
package abc.score;

/**
 * 装飾を表す(未実装も多々あり)
 *
 * @author CrapeMyrtle
 *
 */
public enum EDecoration {
	/** 何もなし */
	NONE,

	/** アクセント */
	ACCENT,
	/** スタッカート */
	STACCATO,
	/** クレッシェンド(開始) */
	CRES_START,
	/** クレッシェンド(終了) */
	CRES_END,
	/** ディミニュエンド(開始) */
	DIMI_START,
	/** ディミニュエンド(終了) */
	DIMI_END,
	/** アルペッジョ */
	ARPEGGIO,
	/** スラー(開始) */
	SLUR_START,
	/** スラー(終了) */
	SLUR_END,
	/** トリル */
	TRILL,
	/** トリル(開始) */
	TRILL_START,
	/** トリル(終了) */
	TRILL_END,
	/** トリル(継続中) */
	IN_TRILL,
	/** モルデント */
	LOWER_MORDENT,
	/** プラルトリラー, 逆モルデント, 転回モルデント */
	UPPER_MORDENT,
	/** ターン */
	TURN,
	/** 転回ターン */
	TURNX,
	/** ターン(音符間) */
	AFTER_TURN,
	/** 転回ターン(音符間) */
	AFTER_TURNX,

	// 独自仕様？
	/** リタルダンド(開始) */
	RITA_START,
	/** リタルダンド(終了) */
	RITA_END,
	/** アッチェレランド(開始) */
	ACCE_START,
	/** アッチェレランド(終了) */
	ACCE_END,
	/** トラック毎のクレッシェンド(開始) */
	TRACK_CRES_START,
	/** トラック毎のクレッシェンド(終了) */
	TRACK_CRES_END,
	/** トラック毎のディミニュエンド(開始) */
	TRACK_DIMI_START,
	/** トラック毎のディミニュエンド(終了) */
	TRACK_DIMI_END,

	// 装飾の上下の臨時記号
	/** 装飾の上下のダブルシャープ */
	DOUBLE_SHARP,
	/** 装飾の上下のシャープ */
	SHARP,
	/** 装飾の上下のナチュラル */
	NATURAL,
	/** 装飾の上下のフラット */
	FLAT,
	/** 装飾の上下のダブルフラット */
	DOUBLE_FLAT,
}
