/**
 *
 */
package abc.score;

/**
 * 調の中で変化記号を表す
 *
 * @author CrapeMyrtle
 *
 */
public enum EKeySignature {
	/** フラット(♭) */
	FLAT("b", "b"),
	/** シャープ(♯) */
	SHARP("#", "#"),
	/** ナチュラル(♮) */
	NATURAL("", "="),
	;

	private String	signHalf	= null;
	private String	signFull	= null;

	/**
	 * コンストラクタ。初期値として文字列表現を設定できる。
	 *
	 * @param signHalf
	 *            セットする文字列表現(半角)
	 * @param signFull
	 *            セットする文字列表現(全角)
	 */
	private EKeySignature(String signHalf, String signFull) {
		this.signFull = signHalf;
		this.signFull = signFull;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Enum#toString()
	 */
	public String toString() {
		return this.getFullString();
	}

	/**
	 * 文字列表現(半角)を返す
	 *
	 * @return 返す文字列表現(半角)
	 */
	public String getHalfString() {
		return this.signHalf;
	}

	/**
	 * 文字列表現(全角)を返す
	 *
	 * @return 返す文字列表現(全角)
	 */
	public String getFullString() {
		return this.signFull;
	}

}
