/**
 *
 */
package abc.score;

/**
 * 連音符を表す
 *
 * @author CrapeMyrtle
 *
 */
public class GroupNote implements Cloneable {
	private int	noteCount;
	private int	wholeTime;
	private int	nextNoteCount;

	/**
	 * コンストラクタ。連音符の(noteCount:wholeTime:nextNoteCount を設定する。
	 * 連音符の後に続くnextNoteCount個数分の音符を、1つあたり 基本長(L:フィールドで設定) * noteCount /
	 * wholeTime の長さで鳴らすようにする。
	 *
	 * @param noteCount nextCount
	 * @param wholeTime wholeTime
	 * @param nextNoteCount nextNoteCount
	 */
	public GroupNote(int noteCount, int wholeTime, int nextNoteCount) {
		this.noteCount = noteCount;
		this.wholeTime = wholeTime;
		this.nextNoteCount = nextNoteCount;
	}

	/* (非 Javadoc)
	 * @see java.lang.Object#clone()
	 */
	public GroupNote clone() {
		return new GroupNote(this.noteCount, this.wholeTime, this.nextNoteCount);
	}

	/**
	 * @return noteCount
	 */
	public int getNoteCount() {
		return noteCount;
	}

	/**
	 * @return wholeTime
	 */
	public int getWholeTime() {
		return wholeTime;
	}

	/**
	 * @return nextNoteCount
	 */
	public int getNextNoteCount() {
		return nextNoteCount;
	}
}
