/**
 *
 */
package abc.score;

/**
 * {@link IInformationFieldClef}の実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldClef extends AInformationField implements Cloneable,
		IInformationFieldClef {

	private Integer	clefOctave		= null;
	private Integer	octave			= null;
	private Integer	transposition	= null;

	/**
	 * コンストラクタ
	 */
	public InformationFieldClef() {
	}

	/**
	 * コンストラクタ
	 *
	 * @param clefOctave
	 *            clef=～に付与されるオクターブ情報
	 * @param octave
	 *            octave=～で指定されるオクターブ情報
	 * @param transposition
	 *            transpose=～で指定される移調情報
	 */
	public InformationFieldClef(Integer clefOctave, Integer octave, Integer transposition) {
		this.clefOctave = clefOctave;
		this.octave = octave;
		this.transposition = transposition;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "(clefOctave=" + this.clefOctave + ", octave=" + this.octave + ", transpose="
				+ this.transposition + ")";
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	public InformationFieldClef clone() {
		return new InformationFieldClef(this.clefOctave, this.octave, this.transposition);
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#getClefOctave()
	 */
	@Override
	public Integer getClefOctave() {
		return this.clefOctave;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#setClefOctave(java.lang.Integer)
	 */
	@Override
	public void setClefOctave(Integer clefOctave) {
		this.clefOctave = clefOctave;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#getOctave()
	 */
	@Override
	public Integer getOctave() {
		return this.octave;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#setOctave(java.lang.Integer)
	 */
	@Override
	public void setOctave(Integer octave) {
		this.octave = octave;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#getTransposition()
	 */
	@Override
	public Integer getTransposition() {
		return this.transposition;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#setTransposition(java.lang.Integer)
	 */
	@Override
	public void setTransposition(Integer transposition) {
		this.transposition = transposition;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see abc.score.IInformationFieldClef#getOctaveTotal()
	 */
	@Override
	public Integer getOctaveTotal() {
		if (this.clefOctave == null && this.octave == null) {
			return null;
		}
		Integer octave = 0;
		if (this.clefOctave != null) {
			octave += this.clefOctave;
		}
		if (this.octave != null) {
			octave += this.octave;
		}
		return octave;
	}
}
