/**
 *
 */
package abc.score;

/**
 * information field (U:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldDefine extends AInformationField implements Cloneable {

	private String	key	= "";
	private String value = "";

	/**
	 * コンストラクタ
	 */
	public InformationFieldDefine() {
	}

	/**
	 * コンストラクタ。キーと値をセットする
	 *
	 * @param key セットするキー
	 * @param value セットする値
	 */
	public InformationFieldDefine(String key, String value) {
		this.key = key;
		this.value = value;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	@Override
	public InformationFieldDefine clone() {
		return new InformationFieldDefine(this.key, this.value);
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "U:(" + this.key + "=" + this.value + ")";
	}

	/**
	 * キーを取得する
	 * @return キー
	 */
	public String getKey() {
		return key;
	}

	/**
	 * キーをセットする
	 * @param key セットするキー
	 */
	public void setKey(String key) {
		this.key = key;
	}

	/**
	 * 値を取得する
	 * @return 値
	 */
	public String getValue() {
		return value;
	}

	/**
	 * 値をセットする
	 * @param value セットする値
	 */
	public void setValue(String value) {
		this.value = value;
	}

}
