/**
 *
 */
package abc.score;


/**
 * information field (K:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldKey extends AInformationField implements Cloneable, IInformationFieldClef {

	private Key	key	= new Key();
	private InformationFieldClef clef = new InformationFieldClef();

	/**
	 * コンストラクタ
	 */
	public InformationFieldKey() {
	}

	/**
	 * コンストラクタ。調で初期化する。
	 * @param key 設定する調
	 * @param clef 設定するclef～オプション
	 */
	public InformationFieldKey(Key key, InformationFieldClef clef) {
		this.key = key;
		this.clef = clef;
	}

	/**
	 * 調を取得する
	 * @return 調
	 */
	public Key getKey() {
		return this.key;
	}

	/**
	 * 調を設定する
	 * @param key 設定する調
	 */
	public void setKey(Key key) {
		this.key = key;
	}

	/**
	 * clefオプションを取得する
	 * @return clefオプション
	 */
	public InformationFieldClef getClef() {
		return clef;
	}

	/**
	 * clefオプションをセットする
	 * @param clef セットするclefオプション
	 */
	public void setClef(InformationFieldClef clef) {
		this.clef = clef;
	}

	/* (非 Javadoc)
	 * @see java.lang.Object#clone()
	 */
	@Override
	public InformationFieldKey clone() {
		return new InformationFieldKey(this.key.clone(), this.clef.clone());
	}

	/* (非 Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "K:(" + this.key.toString() + ")[" + this.clef.toString() + "]";
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getClefOctave()
	 */
	@Override
	public Integer getClefOctave() {
		return this.clef.getClefOctave();
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#setClefOctave(java.lang.Integer)
	 */
	@Override
	public void setClefOctave(Integer clefOctave) {
		this.clef.setClefOctave(clefOctave);
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getOctave()
	 */
	@Override
	public Integer getOctave() {
		return this.clef.getOctave();
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#setOctave(java.lang.Integer)
	 */
	@Override
	public void setOctave(Integer octave) {
		this.clef.setOctave(octave);
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getTransposition()
	 */
	@Override
	public Integer getTransposition() {
		return this.clef.getTransposition();
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#setTransposition(java.lang.Integer)
	 */
	@Override
	public void setTransposition(Integer transposition) {
		this.clef.setTransposition(transposition);
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getOctaveTotal()
	 */
	@Override
	public Integer getOctaveTotal() {
		return this.clef.getOctaveTotal();
	}
}
