/**
 *
 */
package abc.score;

import abc.util.Fraction;

/**
 * information field (L:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldLength extends AInformationField implements Cloneable {

	private Fraction	length	= new Fraction();

	/**
	 * コンストラクタ
	 */
	public InformationFieldLength() {
	}

	/**
	 * コンストラクタ。長さをセットする。
	 *
	 * @param length
	 *            セットする長さ
	 */
	public InformationFieldLength(Fraction length) {
		this.length = length;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	@Override
	public InformationFieldLength clone() {
		return new InformationFieldLength(this.length.clone());
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "L:(" + this.length.toString() + ")";
	}

	/**
	 * 長さを取得する
	 *
	 * @return 長さ
	 */
	public Fraction getLength() {
		return this.length;
	}

	/**
	 * 長さを設定する
	 *
	 * @param length
	 *            設定する長さ
	 */
	public void setLength(Fraction length) {
		this.length = length;
	}

	/**
	 * デフォルトの長さを取得する
	 *
	 * @param meterLength
	 *            Meter
	 * @return デフォルトの長さ
	 */
	public static Fraction getDefaultLength(Fraction meterLength) {
		if (meterLength == null) {
			return new Fraction(1, 8);
		}
		if (meterLength.compareTo(new Fraction(3, 4)) >= 0) {
			return new Fraction(1, 8);
		}
		return new Fraction(1, 16);
	}

}
