/**
 *
 */
package abc.score;

import abc.util.Fraction;


/**
 * information field (M:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldMeter extends AInformationField implements Cloneable {

	private Meter	meter	= new Meter("4/4");

	/**
	 * コンストラクタ
	 */
	public InformationFieldMeter() {
	}

	/**
	 * コンストラクタ。拍子をセットする。
	 *
	 * @param meter
	 *            セットする拍子
	 */
	public InformationFieldMeter(Meter meter) {
		this.meter = meter;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	@Override
	public InformationFieldMeter clone() {
		return new InformationFieldMeter(this.meter.clone());
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "M:(" + this.meter.toString() + ")";
	}

	/**
	 * 拍子を取得する
	 * @return 拍子
	 */
	public Meter getMeter() {
		return this.meter;
	}

	/**
	 * 拍子を設定する
	 * @param meter 拍子
	 */
	public void setMeter(Meter meter) {
		this.meter = meter;
	}

	/**
	 * デフォルトの長さを取得する
	 *
	 * @return デフォルトの長さ
	 */
	public static Fraction getDefaultLength() {
		// TODO デフォルトの長さは"1"でいいのか
		return new Fraction(1);
	}
}
