/**
 *
 */
package abc.score;


/**
 * information field (X:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldReferenceNumber extends AInformationField implements Cloneable {

	private int	refNum	= -1;

	/**
	 * コンストラクタ
	 */
	public InformationFieldReferenceNumber() {
	}

	/**
	 * コンストラクタ。参照番号を設定する。
	 *
	 * @param refNum
	 *            設定する参照番号
	 */
	public InformationFieldReferenceNumber(int refNum) {
		this.refNum = refNum;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	@Override
	public InformationFieldReferenceNumber clone() {
		return new InformationFieldReferenceNumber(this.refNum);
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "X:(" + this.refNum + ")";
	}

	/**
	 * 参照番号を取得する
	 *
	 * @return 参照番号
	 */
	public int getRefNum() {
		return this.refNum;
	}

	/**
	 * 参照番号を設定する
	 *
	 * @param refNum
	 *            設定する参照番号
	 */
	public void setRefNum(int refNum) {
		this.refNum = refNum;
	}

}
