/**
 *
 */
package abc.score;


/**
 * information field (Q:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldTempo extends AInformationField implements Cloneable {

	private Tempo	tempo	= new Tempo();
	private String	text	= "";

	/**
	 * コンストラクタ
	 */
	public InformationFieldTempo() {
	}

	/**
	 * コンストラクタ。テンポを設定する。
	 *
	 * @param tempo
	 *            設定するテンポ
	 */
	public InformationFieldTempo(Tempo tempo) {
		this.tempo = tempo;
	}

	/**
	 * コンストラクタ。テンポとテキストを設定する。
	 *
	 * @param tempo
	 *            設定するテンポ
	 * @param text
	 *            設定するテキスト
	 */
	public InformationFieldTempo(Tempo tempo, String text) {
		this.tempo = tempo;
		this.text = text;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "Q:(" + this.tempo.toString() + " \"" + this.text + "\")";
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	public InformationFieldTempo clone() {
		return new InformationFieldTempo(this.tempo.clone(), this.text);
	}

	/**
	 * テンポを設定する
	 *
	 * @param tempo
	 *            テンポ
	 */
	public void setTempo(Tempo tempo) {
		this.tempo = tempo;
	}

	/**
	 * テンポを取得する
	 *
	 * @return テンポ
	 */
	public Tempo getTempo() {
		return this.tempo;
	}

	/**
	 * テキストを設定する
	 *
	 * @param text
	 *            設定するテキスト
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * テキストを取得する
	 *
	 * @return テキスト
	 */
	public String getText() {
		return this.text;
	}

}
