/**
 *
 */
package abc.score;

/**
 * information field (V:)を表す実装クラス
 *
 * @author CrapeMyrtle
 *
 */
public class InformationFieldVoice extends AInformationField implements Cloneable,
		IInformationFieldClef {

	public static String			DEFAULT_ID	= "defaultTrack";
	private String					id			= DEFAULT_ID;
	private InformationFieldClef	clef		= new InformationFieldClef();

	/**
	 * コンストラクタ
	 */
	public InformationFieldVoice() {
	}

	/**
	 * コンストラクタ。IDを設定する。
	 *
	 * @param id
	 *            設定するID
	 * @param clef
	 *            設定するclefオプション
	 */
	public InformationFieldVoice(String id, InformationFieldClef clef) {
		this.id = id;
		this.clef = clef;
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#clone()
	 */
	@Override
	public InformationFieldVoice clone() {
		return new InformationFieldVoice(this.id, this.clef.clone());
	}

	/*
	 * (非 Javadoc)
	 *
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "V:(" + this.id + ")[" + this.clef.toString() + "]";
	}

	/**
	 * IDを取得する
	 *
	 * @return ID
	 */
	public String getId() {
		return this.id;
	}

	/**
	 * IDを設定する
	 *
	 * @param id
	 *            設定するID
	 */
	public void setId(String id) {
		this.id = id;
	}

	/**
	 * clefオプションを取得する
	 * @return clefオプション
	 */
	public InformationFieldClef getClef() {
		return clef;
	}

	/**
	 * clefオプションをセットする
	 * @param clef セットするclefオプション
	 */
	public void setClef(InformationFieldClef clef) {
		this.clef = clef;
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getClefOctave()
	 */
	@Override
	public Integer getClefOctave() {
		return this.clef.getClefOctave();
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#setClefOctave(java.lang.Integer)
	 */
	@Override
	public void setClefOctave(Integer clefOctave) {
		this.clef.setClefOctave(clefOctave);
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getOctave()
	 */
	@Override
	public Integer getOctave() {
		return this.clef.getOctave();
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#setOctave(java.lang.Integer)
	 */
	@Override
	public void setOctave(Integer octave) {
		this.clef.setOctave(octave);
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getTransposition()
	 */
	@Override
	public Integer getTransposition() {
		return this.clef.getTransposition();
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#setTransposition(java.lang.Integer)
	 */
	@Override
	public void setTransposition(Integer transposition) {
		this.clef.setTransposition(transposition);
	}

	/* (非 Javadoc)
	 * @see abc.score.IInformationFieldClef#getOctaveTotal()
	 */
	@Override
	public Integer getOctaveTotal() {
		return this.clef.getOctaveTotal();
	}
}
