/**
 *
 */
package abc.util;

/**
 * 音符に関するユーティリティ
 * @author CrapeMyrtle
 *
 */
public class NoteUtil {

	/**
	 * 音の長さを出来るだけ簡略化した形で取得する
	 * @param length
	 * @return 音の長さの簡略表現
	 */
	public static String getSimpleLength(Fraction length) {
		if (length.isOne()) {
			return "";
		}

		if (length.isInt()) {
			return "" + length.getNumerator();
		}

		if (length.getNumerator() == 1) {
			return "/" + length.getDenominator();
		}

		return length.toString();
	}
}
