/**
 *
 */
package abc.util;

/**
 * Track合成のID情報を保有する
 * @author CrapeMyrtle
 *
 */
public class TrackSrcDstID {
	private String srcTuneId;
	private String srcTrackId;
	private String dstTuneId;
	private String dstTrackId;

	/**
	 * トラック合成情報
	 * @param srcTuneId 合成元のTuneID
	 * @param srcTrackId 合成元のTrackID
	 * @param dstTuneId 合成先のTuneID
	 * @param dstTrackId 合成先のTrackID
	 */
	public TrackSrcDstID(String srcTuneId, String srcTrackId, String dstTuneId, String dstTrackId) {
		this.srcTuneId = srcTuneId;
		this.srcTrackId = srcTrackId;
		this.dstTuneId = dstTuneId;
		this.dstTrackId = dstTrackId;
	}

	/* (非 Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "{srcTuneId=" + this.srcTuneId
				+ ", srcTrackId=" + this.srcTrackId
				+ ", dstTuneId=" + this.dstTuneId
				+ ", dstTrackId=" + this.dstTrackId
				+ "}";
	}

	/**
	 * 合成元のTuneIDを取得する
	 * @return 合成元のTuneID
	 */
	public String getSrcTuneId() {
		return srcTuneId;
	}

	/**
	 * 合成元のTrackIDを取得する
	 * @return 合成元のTrackID
	 */
	public String getSrcTrackId() {
		return srcTrackId;
	}

	/**
	 * 合成先のTuneIDを取得する
	 * @return 合成先のTuneID
	 */
	public String getDstTuneId() {
		return dstTuneId;
	}

	/**
	 * 合成先のTrackIDを取得する
	 * @return 合成先のTrackID
	 */
	public String getDstTrackId() {
		return dstTrackId;
	}
}
