/**
 *
 */
package util;


/**
 * デバッグ情報を出力する
 *
 * @author CrapeMyrtle
 *
 */
public final class Debug {
	private static Option opt = null;

	/**
	 * オプションをセットする。
	 *
	 * @param opt オプション
	 */
	public static void setOption(Option opt) {
		Debug.opt = opt;
	}

	/**
	 * デバッグ情報を出力する。
	 *
	 * @param obj
	 */
	public static void out(Object obj) {
		if (Debug.opt.isDebug()) {
			StackTraceElement[] traces = new Throwable().getStackTrace();
			if (traces.length >= 2) {
				StackTraceElement trace = traces[1];
				Debug.opt.getDebug().format("[%s:%s] ", trace.getClassName(), trace.getLineNumber());
			}
			Debug.opt.getDebug().println(obj);
		}
	}
}
