package util;

/**
 * 数値計算で使用するユーティリティクラス
 *
 * @author CrapeMyrtle
 *
 */
public final class MathUtil {

	/**
	 * 最小公倍数を計算する
	 *
	 * @param a
	 *            パラメータ
	 * @param b
	 *            パラメータ
	 * @return aとbの最小公倍数
	 */
	public static long gcd(long a, long b) {
		int sign = 1;
		if (a < 0) {
			sign = -sign;
			a = -a;
		}
		if (b < 0) {
			sign = -sign;
			b = -b;
		}

		if (b > a) {
			long temp = a;
			a = b;
			b = temp;
		}

		return sign * (b == 0 ? a : MathUtil.gcd(b, a % b));
	}

	/**
	 * 最大公約数を計算する
	 *
	 * @param a
	 *            パラメータ
	 * @param b
	 *            パラメータ
	 * @return aとbの最大公約数
	 */
	public static long lcm(long a, long b) {
		return a * b / MathUtil.gcd(a, b);
	}
}
